diff options
| author | Glenn Morris | 2018-07-05 21:50:18 -0700 |
|---|---|---|
| committer | Glenn Morris | 2018-07-05 21:50:18 -0700 |
| commit | 6cfc7a7b1bc3989e6d2cc271222ff7ce4eb23b5e (patch) | |
| tree | 2e5620f06b5fbb8fcc289e53f5861b783af1a268 /admin/upload-manuals | |
| parent | b73cde5e2815c531df7f5fd13e214a7d92f78239 (diff) | |
| download | emacs-6cfc7a7b1bc3989e6d2cc271222ff7ce4eb23b5e.tar.gz emacs-6cfc7a7b1bc3989e6d2cc271222ff7ce4eb23b5e.zip | |
Automate upload of Emacs manuals to gnu.org
* admin/make-manuals, admin/upload-manuals: New scripts.
* admin/admin.el (make-manuals, make-manuals-dist): Handle batch mode.
* admin/make-tarball.txt: Update web-page details.
Diffstat (limited to 'admin/upload-manuals')
| -rwxr-xr-x | admin/upload-manuals | 376 |
1 files changed, 376 insertions, 0 deletions
diff --git a/admin/upload-manuals b/admin/upload-manuals new file mode 100755 index 00000000000..1aa7d8be32d --- /dev/null +++ b/admin/upload-manuals | |||
| @@ -0,0 +1,376 @@ | |||
| 1 | #!/bin/bash | ||
| 2 | |||
| 3 | ### upload-manuals - upload the Emacs manuals to the gnu.org website | ||
| 4 | |||
| 5 | ## Copyright 2018 Free Software Foundation, Inc. | ||
| 6 | |||
| 7 | ## Author: Glenn Morris <rgm@gnu.org> | ||
| 8 | |||
| 9 | ## This file is part of GNU Emacs. | ||
| 10 | |||
| 11 | ## GNU Emacs is free software: you can redistribute it and/or modify | ||
| 12 | ## it under the terms of the GNU General Public License as published by | ||
| 13 | ## the Free Software Foundation, either version 3 of the License, or | ||
| 14 | ## (at your option) any later version. | ||
| 15 | |||
| 16 | ## GNU Emacs is distributed in the hope that it will be useful, | ||
| 17 | ## but WITHOUT ANY WARRANTY; without even the implied warranty of | ||
| 18 | ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the | ||
| 19 | ## GNU General Public License for more details. | ||
| 20 | |||
| 21 | ## You should have received a copy of the GNU General Public License | ||
| 22 | ## along with GNU Emacs. If not, see <https://www.gnu.org/licenses/>. | ||
| 23 | |||
| 24 | ### Commentary: | ||
| 25 | |||
| 26 | ## Run this on the output of make-manuals. | ||
| 27 | |||
| 28 | ## We assume you have already checked out a local copy of the website | ||
| 29 | ## following the instructions at | ||
| 30 | ## https://savannah.gnu.org/cvs/?group=emacs | ||
| 31 | |||
| 32 | ## Usage: | ||
| 33 | ## Call from the manual/ directory created by make-manual. | ||
| 34 | ## upload-manuals /path/to/cvs/checkout | ||
| 35 | |||
| 36 | ### Code: | ||
| 37 | |||
| 38 | |||
| 39 | die () # write error to stderr and exit | ||
| 40 | { | ||
| 41 | [ $# -gt 0 ] && echo "$PN: $@" >&2 | ||
| 42 | exit 1 | ||
| 43 | } | ||
| 44 | |||
| 45 | PN=${0##*/} # basename of script | ||
| 46 | |||
| 47 | usage () | ||
| 48 | { | ||
| 49 | cat 1>&2 <<EOF | ||
| 50 | Usage: ${PN} [-m message] [-n] /path/to/cvs/checkout | ||
| 51 | Upload the Emacs manuals to the gnu.org website. | ||
| 52 | Call this script from the manual/ directory created by make-manuals. | ||
| 53 | This script destructively modifies the source directory. | ||
| 54 | Options: | ||
| 55 | -m: commit message to use (default "$message") | ||
| 56 | -n: dry-run (do not commit files) | ||
| 57 | EOF | ||
| 58 | exit 1 | ||
| 59 | } | ||
| 60 | |||
| 61 | |||
| 62 | ## Parameters | ||
| 63 | version=$(gunzip -c info/emacs.info.gz 2> /dev/null | sed -n '0,/updated for Emacs version/s/.*updated for Emacs version \([0-9.]*\).*\.$/\1/p') | ||
| 64 | |||
| 65 | ## Defaults | ||
| 66 | cvs=cvs | ||
| 67 | message="Regenerate manuals for Emacs $version" | ||
| 68 | umessage= | ||
| 69 | |||
| 70 | while getopts ":hm:n" option ; do | ||
| 71 | case $option in | ||
| 72 | (h) usage ;; | ||
| 73 | |||
| 74 | (m) umessage=t ; message="$OPTARG" ;; | ||
| 75 | |||
| 76 | (n) cvs="echo $cvs" ;; | ||
| 77 | |||
| 78 | (\?) die "Bad option -$OPTARG" ;; | ||
| 79 | |||
| 80 | (:) die "Option -$OPTARG requires an argument" ;; | ||
| 81 | |||
| 82 | (*) die "getopts error" ;; | ||
| 83 | esac | ||
| 84 | done | ||
| 85 | shift $(( --OPTIND )) | ||
| 86 | OPTIND=1 | ||
| 87 | |||
| 88 | [ $# -eq 1 ] || usage | ||
| 89 | |||
| 90 | [ "$version$umessage" ] || \ | ||
| 91 | die "Could not get version to use for commit message" | ||
| 92 | |||
| 93 | webdir=$1 | ||
| 94 | |||
| 95 | [ -e $webdir/CVS/Entries ] && [ -e $webdir/refcards/pdf/refcard.pdf ] || \ | ||
| 96 | die "$webdir does not look like a checkout of the Emacs webpages" | ||
| 97 | |||
| 98 | [ -e html_mono/emacs.html ] && [ -e html_node/emacs/index.html ] || \ | ||
| 99 | die "Current directory does not like the manual/ directory" | ||
| 100 | |||
| 101 | |||
| 102 | echo "Doing refcards..." | ||
| 103 | |||
| 104 | mv refcards/emacs-refcards.tar.gz $webdir/refcards/ | ||
| 105 | ( | ||
| 106 | cd $webdir/refcards | ||
| 107 | $cvs commit -m "$message" emacs-refcards.tar.gz || die "commit error" | ||
| 108 | ) | ||
| 109 | |||
| 110 | ## For refcards, we assume a missing file is due to a tex failure, | ||
| 111 | ## rather than a refcard that should be deleted. | ||
| 112 | for fmt in pdf ps.gz; do | ||
| 113 | |||
| 114 | clist= | ||
| 115 | |||
| 116 | for f in $webdir/refcards/${fmt%.gz}/*.$fmt; do | ||
| 117 | |||
| 118 | s=${f#$webdir/} | ||
| 119 | |||
| 120 | if [ -e $s ]; then | ||
| 121 | mv $s $f | ||
| 122 | clist="$clist ${f##*/}" | ||
| 123 | else | ||
| 124 | echo "$s seems to be missing" | ||
| 125 | fi | ||
| 126 | done | ||
| 127 | |||
| 128 | |||
| 129 | ## Check for new files. | ||
| 130 | new= | ||
| 131 | for f in refcards/${fmt%.gz}/*.$fmt; do | ||
| 132 | [ -e $f ] || break | ||
| 133 | new="$new $f" | ||
| 134 | clist="$clist ${f##*/}" | ||
| 135 | done | ||
| 136 | |||
| 137 | [ "$new" ] && mv $new $webdir/refcards/${fmt%.gz}/ | ||
| 138 | |||
| 139 | [ "$clist" ] && ( | ||
| 140 | cd $webdir | ||
| 141 | [ "$new" ] && { | ||
| 142 | echo "Adding new files: $new" | ||
| 143 | $cvs add -kb $new || die "add error" | ||
| 144 | echo "Remember to add new refcards to refcards/index.html" | ||
| 145 | } | ||
| 146 | cd refcards/${fmt%.gz} | ||
| 147 | $cvs commit -m "$message" $clist || die "commit error" | ||
| 148 | ) | ||
| 149 | |||
| 150 | done # $fmt | ||
| 151 | |||
| 152 | |||
| 153 | echo "Doing non-html manuals..." | ||
| 154 | |||
| 155 | for fmt in info pdf ps texi; do | ||
| 156 | |||
| 157 | clist= | ||
| 158 | |||
| 159 | for f in $webdir/manual/$fmt/*; do | ||
| 160 | |||
| 161 | [ ${f##*/} = CVS ] && continue | ||
| 162 | |||
| 163 | s=$fmt/${f##*/} | ||
| 164 | |||
| 165 | if [ -e $s ]; then | ||
| 166 | mv $s $f | ||
| 167 | clist="$clist ${f##*/}" | ||
| 168 | else | ||
| 169 | case ${f##*/} in | ||
| 170 | *_7x9*.pdf) continue ;; | ||
| 171 | esac | ||
| 172 | |||
| 173 | echo "$s seems to be missing" | ||
| 174 | fi | ||
| 175 | done | ||
| 176 | |||
| 177 | ## Check for new files. | ||
| 178 | new= | ||
| 179 | for f in $fmt/*.$fmt*; do | ||
| 180 | [ -e $f ] || break | ||
| 181 | new="$new $f" | ||
| 182 | clist="$clist ${f##*/}" | ||
| 183 | done | ||
| 184 | |||
| 185 | [ "$new" ] && mv $new $webdir/manual/$fmt/ | ||
| 186 | |||
| 187 | [ "$clist" ] && ( | ||
| 188 | cd $webdir/manual | ||
| 189 | [ "$new" ] && { | ||
| 190 | echo "Adding new files: $new" | ||
| 191 | $cvs add $new || die "add error" | ||
| 192 | echo "Remember to add new files to the appropriate index pages" | ||
| 193 | } | ||
| 194 | cd $fmt | ||
| 195 | $cvs commit -m "$message" $clist || die "commit error" | ||
| 196 | ) | ||
| 197 | |||
| 198 | done | ||
| 199 | |||
| 200 | |||
| 201 | echo "Doing tarred html..." | ||
| 202 | |||
| 203 | clist= | ||
| 204 | |||
| 205 | for f in $webdir/manual/*html*.tar*; do | ||
| 206 | |||
| 207 | s=${f##*/} | ||
| 208 | |||
| 209 | if [ -e $s ]; then | ||
| 210 | mv $s $f | ||
| 211 | clist="$clist ${f##*/}" | ||
| 212 | else | ||
| 213 | echo "$s seems to be missing" | ||
| 214 | fi | ||
| 215 | done | ||
| 216 | |||
| 217 | ## Check for new files. | ||
| 218 | new= | ||
| 219 | for f in *html*.tar*; do | ||
| 220 | [ -e $f ] || break | ||
| 221 | new="$new $f" | ||
| 222 | clist="$clist ${f##*/}" | ||
| 223 | done | ||
| 224 | |||
| 225 | [ "$new" ] && mv $new $webdir/manual | ||
| 226 | |||
| 227 | [ "$clist" ] && ( | ||
| 228 | cd $webdir/manual | ||
| 229 | [ "$new" ] && { | ||
| 230 | echo "Adding new files: $new" | ||
| 231 | $cvs add -kb $new || die "add error" | ||
| 232 | echo "Remember to add new files to the appropriate index pages" | ||
| 233 | } | ||
| 234 | $cvs commit -m "$message" $clist || die "commit error" | ||
| 235 | ) | ||
| 236 | |||
| 237 | |||
| 238 | ## This happens so rarely it would be less effort to do by hand... | ||
| 239 | new_manual () { | ||
| 240 | local t=eww | ||
| 241 | local i=$webdir/manual/$t.html # template | ||
| 242 | |||
| 243 | [ -r $i ] || die "Cannot read template $i" | ||
| 244 | |||
| 245 | local name o mono title | ||
| 246 | |||
| 247 | for name; do | ||
| 248 | |||
| 249 | name=${name##*/} | ||
| 250 | name=${name%.html} | ||
| 251 | |||
| 252 | o=$webdir/manual/$name.html | ||
| 253 | |||
| 254 | [ -e $o ] && die "$o already exists" | ||
| 255 | |||
| 256 | mono=$webdir/manual/html_mono/$name.html | ||
| 257 | |||
| 258 | [ -r $mono ] || die "Cannot read $mono" | ||
| 259 | |||
| 260 | title=$(sed -n 's|^<title>\(.*\)</title>|\1|p' $mono) | ||
| 261 | |||
| 262 | : ${title:?} | ||
| 263 | |||
| 264 | echo "$title" | grep -qi "Emacs" || title="Emacs $title" | ||
| 265 | echo "$title" | grep -qi "manual" || title="$title Manual" | ||
| 266 | |||
| 267 | ## It is a pain to extract and insert a good "documenting...". | ||
| 268 | ## Improve it by hand if you care. | ||
| 269 | sed -e "s|^<title>.*\( - GNU Project\)|<title>$title\1|" \ | ||
| 270 | -e "s|^<h2>.*|<h2>$title</h2>|" \ | ||
| 271 | -e "s/^documenting.*/documenting \"$title\"./" \ | ||
| 272 | -e "s/$t/$name/" \ | ||
| 273 | -e "s/©.* Free/\© $(date +%Y) Free/" $i > $o | ||
| 274 | |||
| 275 | ( | ||
| 276 | cd $webdir/manual | ||
| 277 | $cvs add ${o##*/} || die "add error for $o" | ||
| 278 | ) | ||
| 279 | done | ||
| 280 | |||
| 281 | return 0 | ||
| 282 | } | ||
| 283 | |||
| 284 | |||
| 285 | echo "Doing html_mono..." | ||
| 286 | |||
| 287 | clist= | ||
| 288 | |||
| 289 | for f in $webdir/manual/html_mono/*.html; do | ||
| 290 | |||
| 291 | s=${f##*manual/} | ||
| 292 | |||
| 293 | if [ -e $s ]; then | ||
| 294 | mv $s $f | ||
| 295 | clist="$clist ${f##*/}" | ||
| 296 | else | ||
| 297 | echo "$s seems to be missing" | ||
| 298 | fi | ||
| 299 | done | ||
| 300 | |||
| 301 | ## Check for new files. | ||
| 302 | new= | ||
| 303 | for f in html_mono/*.html; do | ||
| 304 | [ -e $f ] || break | ||
| 305 | new="$new $f" | ||
| 306 | clist="$clist ${f##*/}" | ||
| 307 | done | ||
| 308 | |||
| 309 | [ "$new" ] && mv $new $webdir/manual/html_mono/ | ||
| 310 | |||
| 311 | ## TODO: check for removed manuals. | ||
| 312 | |||
| 313 | [ "$clist" ] && ( | ||
| 314 | cd $webdir/manual/html_mono | ||
| 315 | [ "$new" ] && { | ||
| 316 | echo "Adding new files: $new" | ||
| 317 | $cvs add $new || die "add error" | ||
| 318 | new_manual $new || die | ||
| 319 | echo "Remember to add new entries to manual/index.html" | ||
| 320 | } | ||
| 321 | $cvs commit -m "$message" $clist || die "commit error" | ||
| 322 | ) | ||
| 323 | |||
| 324 | |||
| 325 | echo "Doing html_node..." | ||
| 326 | |||
| 327 | for d in html_node/*; do | ||
| 328 | |||
| 329 | [ -e $d ] || break | ||
| 330 | |||
| 331 | echo "Doing $d..." | ||
| 332 | |||
| 333 | [ -e $webdir/manual/$d ] || { | ||
| 334 | echo "New directory: $d" | ||
| 335 | mkdir $webdir/manual/$d | ||
| 336 | $cvs add $webdir/manual/$d || die "add error" | ||
| 337 | } | ||
| 338 | |||
| 339 | new= | ||
| 340 | for f in $d/*.html; do | ||
| 341 | [ -e $webdir/manual/$f ] || new="$new ${f##*/}" | ||
| 342 | done | ||
| 343 | |||
| 344 | stale= | ||
| 345 | for f in $webdir/manual/$d/*.html; do | ||
| 346 | [ -e ${f#$webdir/manual/} ] || stale="$stale ${f##*/}" | ||
| 347 | done | ||
| 348 | |||
| 349 | mv $d/*.html $webdir/manual/$d/ | ||
| 350 | |||
| 351 | ( | ||
| 352 | cd $webdir/manual/$d | ||
| 353 | [ "$new" ] && { | ||
| 354 | echo "Adding new files: $new" | ||
| 355 | $cvs add $new || die "add error" | ||
| 356 | } | ||
| 357 | |||
| 358 | [ "$stale" ] && { | ||
| 359 | echo "Removing stale files: $stale" | ||
| 360 | $cvs remove -f $stale || die "remove error" | ||
| 361 | } | ||
| 362 | |||
| 363 | ## -f: create a new revision even if no change. | ||
| 364 | $cvs commit -f -m "$message" *.html $stale || die "commit error" | ||
| 365 | ) | ||
| 366 | |||
| 367 | done | ||
| 368 | |||
| 369 | |||
| 370 | echo "Checking for stray files..." | ||
| 371 | find -type f | ||
| 372 | |||
| 373 | |||
| 374 | echo "Finished" | ||
| 375 | |||
| 376 | exit 0 | ||